/*
 * Programmieren fuer Physiker, SS 2023, Blatt 3, Aufgabe 9
 *
 * Wochentag zu einem Datum bestimmen
 */

#include <iostream>
using namespace std ;

int main()
{
    const int AnzMonate = 12 ;
    const int TageImMonat[AnzMonate]
	= {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31} ;

    cout << "Wochentag" << endl ;
    cout << "Bitte Datum eingeben: (Tag Monat Jahr): " ;
    int Tag=0, Monat=0, Jahr=0;
    cin >> Tag >> Monat >> Jahr ;

    // Berechne Anzahl der Tage ab 01. 01. 1601 (einschliesslich)
    int JahrDiff = (Jahr-1601) ; // Anzahl der ganzen Jahre seit 1601
    int GesTage = 365*JahrDiff + JahrDiff/4 - JahrDiff/100 + JahrDiff/400 ;
    for( int m=0; m<Monat-1; ++m) GesTage += TageImMonat[m] ;
    if( Monat>=3 and (Jahr%400==0 or (Jahr%4==0 and Jahr%100!=0)))
     	GesTage++ ;
    GesTage += (Tag-1) ;

    cout << Tag << "." << Monat << "." << Jahr << endl ;
    cout << "Zahl der Tage ab 1.1.1601: " <<  GesTage << endl ;

    switch (GesTage%7) 
    {
	case 0 : cout << "Montag" ; break ;
	case 1 : cout << "Dienstag" ; break ;
	case 2 : cout << "Mittwoch" ; break ;
	case 3 : cout << "Donnerstag" ; break ;
	case 4 : cout << "Freitag" ; break ;
	case 5 : cout << "Samstag" ; break ;
	case 6 : cout << "Sonntag" ; break ;
    }
    cout << endl ;

    return 0 ;
}
