/*
 * Programmieren fuer Physiker, SS 2023, Blatt 3, Aufgabe 8 v2
 *
 * Binomial-Koeffizienten per zeilenweiser Berechnung
 *   (modifizierte Version ohne Hilfsfeld)
 */

#include <iostream>
#include <iomanip>
using namespace std ;

int main()
{
    const int nmax=12 ; // Anzahl von zu berechnenden Zeilen
    int zeile[nmax] ; // Speicher fuer die BinoKo der akt. Zeile

    for( int n=0; n<nmax; ++n)
    {
	// Randwerte setzen
	zeile[0] = 1 ;
	zeile[n] = 1 ;

	// Werte per Rek.formel berechnen
	// rueckwaerts die Zeile fuellen verhindert Ueberschreiben 
        // noch benoetigter Werte. Damit insgesamt nur ein Feld noetig.
	for( int k=n-1; k>0; --k)
	    zeile[k] += zeile[k-1] ;
	
	// formatierte Ausgabe
	cout << setw(6*(nmax-n)/2) << zeile[0] ;
	for( int k=1; k<=n; ++k)
	    cout << setw(6) << zeile[k] ;
	cout << endl ;
    }

    return 0 ;
}

	
