/*
 * Programmieren fuer Physiker, SS 2023, Blatt 3, Aufgabe 8
 *
 * Binomial-Koeffizienten per zeilenweiser Berechnung
 */

#include <iostream>
#include <iomanip>
using namespace std ;

int main()
{
    const int nmax=15 ;  // Groesse des Pascal-Dreiecks
    int zeile[nmax] ;    // aktuelle Zeile
    int zeiletmp[nmax] ; // Hilfszeile (Vorgaenger-Zeile)

    for( int n=0; n<nmax; ++n)  // gehe die Zeilen ab...
    { 
	// sichere die bisherige Zeile (hat Laenge n)
	for( int k=0; k<n; ++k)
	    zeiletmp[k] = zeile[k] ;

	// setze die "Randwerte" der neuen Zeile
	zeile[0] = 1 ;
	zeile[n] = 1 ;

	// berechne die neue Zeile aus der Vorgaengerzeile
	for( int k=1; k<n; ++k)
	    zeile[k] = zeiletmp[k] + zeiletmp[k-1] ;

	// Zeile ausgeben
	cout << setw(6*(nmax-n)/2) << zeile[0] ;
	for( int k=1; k<=n; k++)
	    cout << setw(6) << zeile[k] ;
	cout << endl ;
    }

    return 0 ;
}
